
/******************************************************************************
* MODULE     : rational.gen.h
* DESCRIPTION: rationals based on gmp
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <Arithmetic/integer.gen.h>

#module rational
#import integer

struct rational_rep: public concrete_struct {
  mpq_t Q;
  inline rational_rep () { mpq_init (Q); }
  inline ~rational_rep () { mpq_clear (Q); }
};

class rational {
#import concrete (rational, rational_rep)
public:
  rational ();
  rational (int i);
  rational (integer i);
  operator string ();
  operator tree ();
};
#import code_concrete (rational, rational_rep)

ostream& operator << (ostream& out, rational i);
rational operator + (rational i, rational j);
rational operator - (rational i);
rational operator - (rational i, rational j);
rational operator * (rational i, rational j);
rational operator / (rational i, rational j);

inline void operator += (rational& i, rational j) { i=i+j; }
inline void operator -= (rational& i, rational j) { i=i-j; }
inline void operator *= (rational& i, rational j) { i=i*j; }
inline void operator /= (rational& i, rational j) { i=i/j; }

#endmodule // rational
