
/******************************************************************************
* MODULE     : relaxed.gen.h
* DESCRIPTION: relaxed power series
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <Univariate/series.gen.h>

#module relaxed (C)
#import series (C)

class implicit_series_rep<C>: public series_rep<C> {
public:
  int        r;    // one of the above types
  series<C>  eq;   // the equation

private:
  inline implicit_series_rep<C> (int r2): series_rep<C> (RELAXED), r (r2) {
    n    = r;
    value= zealous<C> (r);
  }
  inline ~implicit_series_rep<C> () {}
  inline C next () { return n<r? value[n]: eq[n]; }
  inline operator tree () { return tree ("implicit"); }

public:
  void set_precision (int terms);
  friend class implicit_series<C>;
};

class implicit_series<C> {
#import extend_null (series<C>,implicit_series<C>,implicit_series_rep<C>)
public:
  implicit_series<C> (int r);
  C& operator () (int n);
  C  operator [] (int n);
  zealous<C> operator () (int start, int end);
};
#import code_extend_null (series<C>,implicit_series<C>,implicit_series_rep<C>)

#endmodule // relaxed (C)
