
/******************************************************************************
* MODULE     : pgr_test.gen.cc
* DESCRIPTION: Test program
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <program.gen.h>
#include <compiler.gen.h>
#include <file.gen.h>

#module code_prg_test
#import program
#import compiler
#import file

program lisp_expr_to_program (string s, location root);
void    initialize_system (compiler cpl);

compiler cpl;

instance
get_print (type t) {
  t= composite ("->", t, "Void");
  int i;
  array<instance> a= cpl->env["print!"];
  for (i=0; i<N(a); i++)
    if (a[i]->t==t) return a[i];
  cerr << "Fatal error: no printing method available for " << t << "\n";
  exit (1);
}

int
main () {
  char in[1000];
  string s;
  bool flag=TRUE;
  initialize_system (cpl);

  while (TRUE) {
    int i;
    for (i=0; i<999; i++) {
      cin.get(in[i]);
      if (in[i]=='\n') break;
    }
    in[i]='\0';
    if (in[0]==']') {
      string name (&in[1]);
      cout << "Loading " << name << "\n";
      load_string (in+1, s, TRUE);
    }
    else s= string (in);
    if (s == "quit") break;
    if (s == "vars") { cout << cpl->env << "\n"; continue; }
    if (s == "$") { flag= !flag; continue; }

    program p (lisp_expr_to_program (s, 0));
    if (!flag) cout << "-> " << p << "\n";
    list<typed_program> ltp= cpl->compile (p);
    if (flag) {
      if (nil (ltp)) cout << "=> Compilation failed\n";
      else if (!atom (ltp)) cout << "=> Ambiguous expression\n";
      else {
	program P (ltp->item->p);
	type    T (ltp->item->t);
	if (!is_string (T, "Void")) P= composite (get_print (T), P);

	cout << "=> ";
	execute (P);
	cout << " : " << T << "\n";
      }
    }
    else cout << "=> " << ltp << "\n";
  }
  return 0;
}

#endmodule // prg_test
