
/******************************************************************************
* MODULE     : track_event.gen.cc
* DESCRIPTION: Track keyboard and mouse events
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <window.gen.h>
#include <Widget/basic_widget.gen.h>

#module code_track_event
#import window
#import basic_widget

/******************************************************************************
* Test widget
******************************************************************************/

class track_widget_rep: public basic_widget_rep {
public:
  track_widget_rep (display dis);
  operator tree ();
  void handle_get_size (get_size_event ev);
  void handle_repaint (repaint_event ev);
  void handle_keypress (keypress_event ev);
  void handle_mouse (mouse_event ev);
};

track_widget_rep::track_widget_rep (display dis): basic_widget_rep (dis) {}

widget
track_widget (display dis) {
  return new track_widget_rep (dis);
}

track_widget_rep::operator tree () {
  return "test";
}

void
track_widget_rep::handle_get_size (get_size_event ev) {
  if (ev->mode==-1) { ev->w= ev->w/2; ev->h= ev->h/2; }
  if (ev->mode== 1) { ev->w= ev->w*2; ev->h= ev->h*2; }
}

void
track_widget_rep::handle_repaint (repaint_event ev) { (void) ev;
  win->set_color (dis->white);
  win->fill (ev->x1, ev->y1, ev->x2, ev->y2);

  int i;
  for (i=0; i<=63; i++) {
    int r= (i&3)*85;
    int g= ((i>>2)&3)*85;
    int b= ((i>>4)&3)*85;
    win->set_line_style (2*PIXEL);
    win->set_color (dis->rgb (r,g,b));
    win->line (0, 0, (i*w)/64, -h);
  }
}

void
track_widget_rep::handle_keypress (keypress_event ev) {
  cout << ((event) ev) << "\n";
}

void
track_widget_rep::handle_mouse (mouse_event ev) {
  cout << ((event) ev) << "\n";
}

/******************************************************************************
* The main program
******************************************************************************/

int
main (int argc, char** argv) {
  display dis= open_display (argc, argv);
  window w1= plain_window (track_widget (dis), "event tracker");
  w1->map ();
  dis->event_loop ();
  close_display (dis);
  return 0;
}

#endmodule // code_track_event
