
/******************************************************************************
* MODULE     : edit_typeset.gen.h
* DESCRIPTION: the typeset structure for the mathematical editor
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <env.gen.h>
#include <edit_base.gen.h>

#module edit_typeset
#import env
#import edit_base

class document_rep;
class edit_typeset: virtual public edit_base {
protected:
  tree the_style;             // document style
  hashmap<string,tree> init;  // initial environment
  hashmap<string,tree> fin ;  // final environment
  edit_env env;               // the environment for typesetting
  document_rep* doc;          // the yet or not yet typesetted document

public:
  edit_typeset (tm_buffer buf);
  ~edit_typeset ();

  tree get_env_value (string var_name);
  tree get_init_value (string var_name);
  void init_style (string style);
  void init_extra_style (string extra_style);
  void init_env (hashmap<string,tree> H= hashmap<string,tree> ("?"));
  void init_env (string var, tree by);
  void init_default (string var);
  void typeset_notify_modify (int pos);
  void typeset_notify_assign (int nr);
  void typeset_notify_insert (int pos, int nr);
  void typeset_notify_remove (int pos, int nr);
  void typeset (SI& x1, SI& y1, SI& x2, SI& y2);
  void reprocess_all ();

  friend class tm_window_rep;
  friend class tm_data_rep;
  friend class tm_project_rep;
  friend class tm_server_rep;
};

#endmodule // edit_typeset
