
/******************************************************************************
* MODULE     : language.gen.cc
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <language.gen.h>

#module code_language
#import language
#import code_resource (language_rep,language)

language
text_language (string s) {
  if (resource<language> -> contains (s)) return language (s);
  if (s == "dutch") return new dutch_rep ();
  if (s == "english") return new english_rep ();
  if (s == "french") return new french_rep ();
  if (s == "german") return new german_rep ();
  if (s == "verbatim") return new verbatim_rep ();
  fatal_error ("unknown language", "text_language");
}

language
math_language (string name) {
  if (resource<language> -> contains (name)) return language (name);
  string s, fname= name * ".syx";
  if (debug (0)) cout << "TeXmacs] Loading " << fname << "\n";
  load_string ("$TEXMACS_SYNTAX_PATH", fname, s, TRUE);
  return new math_language_rep (name, s);
}

language
prog_language (string s) {
  if (resource<language> -> contains (s)) return language (s);
  return make<language> (s, new verbatim_rep ());
}

#endmodule // language
