
/******************************************************************************
* MODULE     : translator.gen.cc
* DESCRIPTION: used for the translation of tokens, mainly to name symbols
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <file.gen.h>
#include <translator.gen.h>

#module code_translator
#import file
#import translator
#import code_resource (translator_rep, translator)

/******************************************************************************
* Routines for translators
******************************************************************************/

translator&
operator << (translator& trl, int i) {
  trl->cur_c= i;
  return trl;
}

translator&
operator << (translator& trl, string s) {
  if (N(s)>0) {
    if (N(s)>1) s= "<" * s * ">";
    trl->dict(s) = string ((char) ((unsigned char) (trl->cur_c & 255)));
  }
  trl->cur_c++;
  return trl;
}

/******************************************************************************
* Loading translators
******************************************************************************/

translator
load_translator (string name) {
  if (resource<translator> -> contains (name))
    return translator (name);
  translator trl= new translator_rep (name);

  string s, r;
  name= name * ".enc";
  if (debug (0)) cout << "TeXmacs] Loading " << name << "\n";
  load_string ("$TEXMACS_HOME_PATH/fonts/enc:$TEXMACS_PATH/fonts/enc",
	       name, s, TRUE);
  
  int i, num=0;
  for (i=0; i<N(s); i++)
    switch (s[i]) {
    case '\"': // "
      r= "";
      for (i++; i<N(s); i++) {
	if ((s[i]=='\\') && (i<N(s)-1)) i++;
	else if (s[i]=='\"') break; // "
	r << s[i];
      }
      trl << r;
      num= 0;
      break;
    case '0': case '1': case '2': case '3': case '4':
    case '5': case '6': case '7': case '8': case '9':
      if (i==N(s)-1) break;
      num= 10*num+ ((int) s[i])- ((int) '0');
      trl << num;
      break;
    default:
      num= 0;
    }
  return trl;
}

#endmodule // translator
