
/******************************************************************************
* MODULE     : translator.gen.h
* DESCRIPTION: used for the translation of tokens, mainly to name symbols
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <resource.gen.h>

#module translator
#import string
#import hashmap (string, string)
#import resource (translator_rep,translator)

/******************************************************************************
* The translator structure
******************************************************************************/

struct translator_rep: rep<translator> {
  int                     cur_c;
  hashmap<string,string>  dict;

  inline translator_rep (string s);
};

inline translator_rep::translator_rep (string s):
  rep<translator> (s), cur_c (0), dict ("") {}

translator& operator << (translator& trl, int i);
translator& operator << (translator& trl, string s);

translator load_translator (string name);

#endmodule // translator
