
/****************************************************************************
* Initialization file for interactive compiler and executor
* This file has been generated automatically by the command
*   gen_init Texmacs/Lisp/init_server.ext server server "x"
****************************************************************************/

#module code_prg_server

#ifndef __FUNCTION_server
#define __FUNCTION_server

class server_function_rep: public function_rep {
protected:
  server x;
  pointer (*r)(server, program);
  string  s;

public:
  server_function_rep (server x2, pointer (*r2) (server, program), string s2):
    x (x2), r (r2), s (s2) {}
  pointer execute (program p) { return r (x, p); }
  operator tree () { return tree ("server$" * s); }
  void print (ostream& out) { out << "server$" << s; }
};

class server_instance_rep: public instance_rep {
public:
  server x;
  pointer (*f) (server, program);
  string  s;

  server_instance_rep (string name, type t, server x2, pointer (*f2) (server, program)):
    instance_rep (name, t), x (x2), f (f2), s (name) {}
  pointer execute () { return (pointer) new function (new server_function_rep (x, f, s)); }
};

extern program lisp_to_program (string, int&, int);

void
primitive (compiler cpl, string name, server x, string t, pointer (*r)(server, program)) {
  int i=0;
  program p (lisp_to_program (t, i, 0));
  instance ins (new server_instance_rep (name, p, x, r));
  cpl->env->define_var (ins);
}

#endif

/****************************************************************************
* Main routines
****************************************************************************/

pointer
prg_server_0 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  x->set_input_language (*arg0);
  delete arg0;
  return NULL;
}

pointer
prg_server_1 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  x->set_output_language (*arg0);
  delete arg0;
  return NULL;
}

pointer
prg_server_2 (server x, program p) {
  program* arg0 = (program*) execute (p[1]);
  program* arg1 = (program*) execute (p[2]);
  x->set_keymap (*arg0, *arg1);
  delete arg0;
  delete arg1;
  return NULL;
}

pointer
prg_server_3 (server x, program p) {
  program* arg0 = (program*) execute (p[1]);
  x->set_latex_commands (*arg0);
  delete arg0;
  return NULL;
}

pointer
prg_server_4 (server x, program p) {
  program* arg0 = (program*) execute (p[1]);
  x->set_latex_symbols (*arg0);
  delete arg0;
  return NULL;
}

pointer
prg_server_5 (server x, program p) {
  program* arg0 = (program*) execute (p[1]);
  string* arg1 = (string*) execute (p[2]);
  string* arg2 = (string*) execute (p[3]);
  program* arg3 = (program*) execute (p[4]);
  x->set_shorthands (*arg0, *arg1, *arg2, *arg3);
  delete arg0;
  delete arg1;
  delete arg2;
  delete arg3;
  return NULL;
}

pointer
prg_server_6 (server x, program p) {
  program* arg0 = (program*) execute (p[1]);
  x->set_font_rules (*arg0);
  delete arg0;
  return NULL;
}

pointer
prg_server_7 (server x, program p) {
  program** arg0 = (program**) execute (p[1]);
  program* arg1 = (program*) execute (p[2]);
  x->menu_set (**arg0, *arg1);
  delete arg0;
  delete arg1;
  return NULL;
}

pointer
prg_server_8 (server x, program p) {
  program** arg0 = (program**) execute (p[1]);
  program* arg1 = (program*) execute (p[2]);
  x->menu_merge (**arg0, *arg1);
  delete arg0;
  delete arg1;
  return NULL;
}

pointer
prg_server_9 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  string* arg1 = (string*) execute (p[2]);
  x->lisp_eval_file (*arg0, *arg1);
  delete arg0;
  delete arg1;
  return NULL;
}

pointer
prg_server_10 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  x->execute (*arg0);
  delete arg0;
  return NULL;
}

pointer
prg_server_11 (server x, program p) {
  program* arg0 = (program*) execute (p[1]);
  x->execute (*arg0);
  delete arg0;
  return NULL;
}

pointer
prg_server_12 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  x->shell (*arg0);
  delete arg0;
  return NULL;
}

pointer
prg_server_13 (server x, program p) { (void) p;
  int res (x->no_name ());
  return (pointer) new int (res);
}

pointer
prg_server_14 (server x, program p) { (void) p;
  int res (x->exists_unsaved_buffer ());
  return (pointer) new int (res);
}

pointer
prg_server_15 (server x, program p) { (void) p;
  x->pretend_save_buffer ();
  return NULL;
}

pointer
prg_server_16 (server x, program p) { (void) p;
  string res (x->get_name_buffer ());
  return (pointer) new string (res);
}

pointer
prg_server_17 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  x->set_name_buffer (*arg0);
  delete arg0;
  return NULL;
}

pointer
prg_server_18 (server x, program p) { (void) p;
  x->new_buffer ();
  return NULL;
}

pointer
prg_server_19 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  x->switch_to_buffer (*arg0);
  delete arg0;
  return NULL;
}

pointer
prg_server_20 (server x, program p) { (void) p;
  x->revert_buffer ();
  return NULL;
}

pointer
prg_server_21 (server x, program p) { (void) p;
  x->kill_buffer ();
  return NULL;
}

pointer
prg_server_22 (server x, program p) { (void) p;
  x->open_window ();
  return NULL;
}

pointer
prg_server_23 (server x, program p) { (void) p;
  x->clone_window ();
  return NULL;
}

pointer
prg_server_24 (server x, program p) { (void) p;
  x->kill_window ();
  return NULL;
}

pointer
prg_server_25 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  string* arg1 = (string*) execute (p[2]);
  x->load_buffer (*arg0, *arg1);
  delete arg0;
  delete arg1;
  return NULL;
}

pointer
prg_server_26 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  string* arg1 = (string*) execute (p[2]);
  string* arg2 = (string*) execute (p[3]);
  x->load_buffer (*arg0, *arg1, *arg2);
  delete arg0;
  delete arg1;
  delete arg2;
  return NULL;
}

pointer
prg_server_27 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  x->load_generic_buffer (*arg0);
  delete arg0;
  return NULL;
}

pointer
prg_server_28 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  string* arg1 = (string*) execute (p[2]);
  x->load_generic_buffer (*arg0, *arg1);
  delete arg0;
  delete arg1;
  return NULL;
}

pointer
prg_server_29 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  int* arg1 = (int*) execute (p[2]);
  x->load_generic_buffer (*arg0, *arg1);
  delete arg0;
  delete arg1;
  return NULL;
}

pointer
prg_server_30 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  string* arg1 = (string*) execute (p[2]);
  int* arg2 = (int*) execute (p[3]);
  x->load_generic_buffer (*arg0, *arg1, *arg2);
  delete arg0;
  delete arg1;
  delete arg2;
  return NULL;
}

pointer
prg_server_31 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  string* arg1 = (string*) execute (p[2]);
  x->save_buffer (*arg0, *arg1);
  delete arg0;
  delete arg1;
  return NULL;
}

pointer
prg_server_32 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  string* arg1 = (string*) execute (p[2]);
  string* arg2 = (string*) execute (p[3]);
  x->save_buffer (*arg0, *arg1, *arg2);
  delete arg0;
  delete arg1;
  delete arg2;
  return NULL;
}

pointer
prg_server_33 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  x->save_generic_buffer (*arg0);
  delete arg0;
  return NULL;
}

pointer
prg_server_34 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  string* arg1 = (string*) execute (p[2]);
  x->save_generic_buffer (*arg0, *arg1);
  delete arg0;
  delete arg1;
  return NULL;
}

pointer
prg_server_35 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  string* arg1 = (string*) execute (p[2]);
  string* arg2 = (string*) execute (p[3]);
  string* arg3 = (string*) execute (p[4]);
  string* arg4 = (string*) execute (p[5]);
  x->recover_auto_save (*arg0, *arg1, *arg2, *arg3, *arg4);
  delete arg0;
  delete arg1;
  delete arg2;
  delete arg3;
  delete arg4;
  return NULL;
}

pointer
prg_server_36 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  x->project_attach (*arg0);
  delete arg0;
  return NULL;
}

pointer
prg_server_37 (server x, program p) { (void) p;
  x->project_attach ();
  return NULL;
}

pointer
prg_server_38 (server x, program p) { (void) p;
  int res (x->project_attached ());
  return (pointer) new int (res);
}

pointer
prg_server_39 (server x, program p) { (void) p;
  x->project_compile_all ();
  return NULL;
}

pointer
prg_server_40 (server x, program p) { (void) p;
  x->project_compile_buffer ();
  return NULL;
}

pointer
prg_server_41 (server x, program p) { (void) p;
  x->quit ();
  return NULL;
}

pointer
prg_server_42 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  x->quit (*arg0);
  delete arg0;
  return NULL;
}

pointer
prg_server_43 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  string* arg1 = (string*) execute (p[2]);
  string* arg2 = (string*) execute (p[3]);
  string* arg3 = (string*) execute (p[4]);
  x->declare (*arg0, *arg1, *arg2, *arg3);
  delete arg0;
  delete arg1;
  delete arg2;
  delete arg3;
  return NULL;
}

pointer
prg_server_44 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  string* arg1 = (string*) execute (p[2]);
  string* arg2 = (string*) execute (p[3]);
  string res (x->evaluate (*arg0, *arg1, *arg2));
  delete arg0;
  delete arg1;
  delete arg2;
  return (pointer) new string (res);
}

pointer
prg_server_45 (server x, program p) {
  string* arg0 = (string*) execute (p[1]);
  string* arg1 = (string*) execute (p[2]);
  string* arg2 = (string*) execute (p[3]);
  string res (x->execute (*arg0, *arg1, *arg2));
  delete arg0;
  delete arg1;
  delete arg2;
  return (pointer) new string (res);
}

/****************************************************************************
* Initialize
****************************************************************************/

void
initialize_server (compiler cpl, server x) {
  // cpl->define ("Bool", program ("Type"));
  // cpl->define ("Int", program ("Type"));
  // cpl->define ("String", program ("Type"));
  // cpl->define ("Program", program ("Type"));
  primitive (cpl, "set_input_language", x, "(-> String Void)", prg_server_0);
  primitive (cpl, "set_output_language", x, "(-> String Void)", prg_server_1);
  primitive (cpl, "set_keymap", x, "(-> (Cross Program Program) Void)", prg_server_2);
  primitive (cpl, "set_latex_commands", x, "(-> Program Void)", prg_server_3);
  primitive (cpl, "set_latex_symbols", x, "(-> Program Void)", prg_server_4);
  primitive (cpl, "set_shorthands", x, "(-> (Cross Program String String Program) Void)", prg_server_5);
  primitive (cpl, "set_font_rules", x, "(-> Program Void)", prg_server_6);
  primitive (cpl, "menu_set", x, "(-> (Cross (& Program) Program) Void)", prg_server_7);
  primitive (cpl, "menu_merge", x, "(-> (Cross (& Program) Program) Void)", prg_server_8);
  primitive (cpl, "lisp_eval_file", x, "(-> (Cross String String) Void)", prg_server_9);
  primitive (cpl, "execute", x, "(-> String Void)", prg_server_10);
  primitive (cpl, "execute", x, "(-> Program Void)", prg_server_11);
  primitive (cpl, "shell", x, "(-> String Void)", prg_server_12);
  primitive (cpl, "no_name", x, "(-> Void Bool)", prg_server_13);
  primitive (cpl, "exists_unsaved_buffer", x, "(-> Void Bool)", prg_server_14);
  primitive (cpl, "pretend_save_buffer", x, "(-> Void Void)", prg_server_15);
  primitive (cpl, "get_name_buffer", x, "(-> Void String)", prg_server_16);
  primitive (cpl, "set_name_buffer", x, "(-> String Void)", prg_server_17);
  primitive (cpl, "new_buffer", x, "(-> Void Void)", prg_server_18);
  primitive (cpl, "switch_to_buffer", x, "(-> String Void)", prg_server_19);
  primitive (cpl, "revert_buffer", x, "(-> Void Void)", prg_server_20);
  primitive (cpl, "kill_buffer", x, "(-> Void Void)", prg_server_21);
  primitive (cpl, "open_window", x, "(-> Void Void)", prg_server_22);
  primitive (cpl, "clone_window", x, "(-> Void Void)", prg_server_23);
  primitive (cpl, "kill_window", x, "(-> Void Void)", prg_server_24);
  primitive (cpl, "load_buffer", x, "(-> (Cross String String) Void)", prg_server_25);
  primitive (cpl, "load_buffer", x, "(-> (Cross String String String) Void)", prg_server_26);
  primitive (cpl, "load_generic_buffer", x, "(-> String Void)", prg_server_27);
  primitive (cpl, "load_generic_buffer", x, "(-> (Cross String String) Void)", prg_server_28);
  primitive (cpl, "load_generic_buffer", x, "(-> (Cross String Int) Void)", prg_server_29);
  primitive (cpl, "load_generic_buffer", x, "(-> (Cross String String Int) Void)", prg_server_30);
  primitive (cpl, "save_buffer", x, "(-> (Cross String String) Void)", prg_server_31);
  primitive (cpl, "save_buffer", x, "(-> (Cross String String String) Void)", prg_server_32);
  primitive (cpl, "save_generic_buffer", x, "(-> String Void)", prg_server_33);
  primitive (cpl, "save_generic_buffer", x, "(-> (Cross String String) Void)", prg_server_34);
  primitive (cpl, "recover_auto_save", x, "(-> (Cross String String String String String) Void)", prg_server_35);
  primitive (cpl, "project_attach", x, "(-> String Void)", prg_server_36);
  primitive (cpl, "project_detach", x, "(-> Void Void)", prg_server_37);
  primitive (cpl, "project_attached", x, "(-> Void Bool)", prg_server_38);
  primitive (cpl, "project_compile_all", x, "(-> Void Void)", prg_server_39);
  primitive (cpl, "project_compile_buffer", x, "(-> Void Void)", prg_server_40);
  primitive (cpl, "quit", x, "(-> Void Void)", prg_server_41);
  primitive (cpl, "quit", x, "(-> String Void)", prg_server_42);
  primitive (cpl, "declare_package", x, "(-> (Cross String String String String) Void)", prg_server_43);
  primitive (cpl, "evaluate", x, "(-> (Cross String String String) String)", prg_server_44);
  primitive (cpl, "execute", x, "(-> (Cross String String String) String)", prg_server_45);
}

#endmodule // code_prg_server

