
/******************************************************************************
* MODULE     : tm_lisp.gen.h
* DESCRIPTION: TeXmacs-lisp motor
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <server.gen.h>

#module tm_lisp
#import server

class tm_lisp_rep: virtual public server_rep {
protected:
  compiler cpl;         // TeXmacs lisp compiler
  array<program> cmds;  // commands which are still to be executed

public:
  tm_lisp_rep ();
  ~tm_lisp_rep ();

  /* TeXmacs-lisp motor */
  program convert (string s);
  program compile (program p);
  void execute (program p);
  void execute (string s);
  void lisp_eval_file (string dir, string name);
  void execute_delayed (program p);
  void execute_pending_commands ();
};

#endmodule // tm_lisp
