
/******************************************************************************
* MODULE     : typeset.gen.h
* DESCRIPTION: the mathematical typesetter converts trees into boxes,
*              given a typeset-environment.
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <Boxes/boxes.gen.h>
#include <env.gen.h>
#include <data.gen.h>

#module typesetter
#import boxes
#import env
#import data

class typesetter_rep {
public:
  edit_env env;

  typesetter_rep (edit_env env);

  box typeset_string (string s);
  box typeset_document (tree t);
  box typeset_paragraph (tree t);
  box typeset_concat (tree t);
  box typeset_space (tree t);
  box typeset_move (tree t);
  box typeset_resize (tree t);

  box typeset_frac (tree t);
  box typeset_sqrt (tree t);
  box typeset_wide (tree t);
  box typeset_neg (tree t);
  box typeset_tree (tree t);
  box typeset_sub (tree t);
  box typeset_sup (tree t);
  box typeset_sub_sup (tree t);
  box typeset_mode (tree t, int mode);
  box typeset_matrix (tree t);
  box typeset_table (tree t);
  box typeset_mosaic (tree t);

  box typeset_graphics (tree t);
  box typeset_point (tree t);
  box typeset_line (tree t);
  box typeset_arc (tree t);
  box typeset_bezier (tree t);
  box typeset_postscript (tree t);

  box typeset (tree t);
};

typedef typesetter_rep* typesetter;

#endmodule // typesetter
