
/******************************************************************************
* MODULE     : composite.gen.h
* DESCRIPTION: composite boxes
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <Boxes/boxes.gen.h>
#include <array.gen.h>

#module composite_boxes
#import boxes
#import array (box)
#import array (int)

typedef array<int> array<SI>;

/******************************************************************************
* Composite boxes
******************************************************************************/

struct composite_box_rep: public box_rep {
  array<box> bs;

  composite_box_rep ();
  composite_box_rep (array<box> bs);
  composite_box_rep (array<box> bs, array<SI> x, array<SI> y);
  ~composite_box_rep ();

  void    insert (box b, SI x, SI y);
  void    position ();
  void    left_justify ();
  void    display (ps_device dev);
  int     subnr ();
  box     subbox (int i);
  virtual cursor get_cursor (path p);
  virtual path   get_path (SI x, SI y, SI delta);
  virtual SI     sub_base ();
  virtual SI     sup_base ();
};

#endmodule // composite_boxes
