
/******************************************************************************
* MODULE     : modifier.gen.h
* DESCRIPTION: a modifier box modifies the behaviour of another box
*              as to cursor movements etc. , but displays in the same way
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <Boxes/boxes.gen.h>

#module modifier_boxes
#import boxes

class modifier_box_rep: public box_rep {
public:
  box b;

  modifier_box_rep (box b);
  ~modifier_box_rep ();

  int       subnr ();
  box       subbox (int i);
  void      display (ps_device dev);  
  operator  tree ();

  virtual path encode (path p);
  virtual path decode (path p);
  path         get_path (SI x, SI y, SI delta);
  cursor       get_cursor (path p);  
  path         left_path ();
  path         right_path ();
  selection    select (path start, path end);

  double    left_slope ();
  double    right_slope ();
  SI        sub_base ();
  SI        sup_base ();
  SI        left_correction ();
  SI        right_correction ();
  SI        left_sub_correction (double level);
  SI        left_sup_correction (double level);
  SI        right_sub_correction (double level);
  SI        right_sup_correction (double level);
};

#endmodule // modifier_boxes
