
/******************************************************************************
* MODULE     : document.gen.h
* DESCRIPTION: The result of typesetting a paragraph is
*              an instance of the paragraph class
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <Document/paragraph.gen.h>
#include <Document/pager.gen.h>

#module document
#import paragraph
#import pager

class document_rep {
  tree&            et;
  edit_env&        env;
  array<paragraph> p;
  rectangle        r;

public:
  document_rep (tree& et, edit_env& env);
  void notify_modify (int pos);
  void notify_assign (int nr);
  void notify_insert (int pos, int nr);
  void notify_remove (int pos, int nr);

  void change_env (tree t, path p);
  tree get_env (string var, path p);
  void typeset_paragraph (int nr);
  box  typeset (SI& x1, SI& y1, SI& x2, SI& y2);
};

#endmodule // document
