
/******************************************************************************
* MODULE     : page_item.gen.h
* DESCRIPTION: A typesetted document consists of an array of page_items.
*              Each page item contains spacing and page breaking information.
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#module page_item

#define PAGE_LINE_ITEM      0
#define PAGE_CONTROL_ITEM   1

class page_item;
class page_item_rep: public concrete_struct {
public:
  int        type;    // type of the page item

  box        b;       // the box
  path       p;       // the path in the tree
  path       q;       // set if cursor belongs to previous item at extreme left
  int        f;       // border flags
  space      spc;     // separation space
  int        penalty; // penalty for a linebreak after this page_item

  tree       t;       // for page control items

  page_item_rep (box b, path p, path q, int f);
  page_item_rep (tree t);
  page_item_rep (page_item old, int par_nr);
};

class page_item {
#import concrete_null (page_item, page_item_rep)
  page_item (box b, path p, path q, int f);
  page_item (tree r);
  page_item (page_item old, int par_nr);
  bool operator == (page_item item2);
  bool operator != (page_item item2);
};
#import code_concrete_null (page_item, page_item_rep)

ostream& operator << (ostream& out, page_item item);
#define no_tree_converter<page_item>
#import array (page_item)

#endmodule // page_item
