
/******************************************************************************
* MODULE     : pager.gen.cc
* DESCRIPTION: Places typesetted paragraphs on pages
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <Paragraph/line_item.gen.h>
#include <Document/page_item.gen.h>

#module pager
#import line_item
#import page_item
#import array (box)
#import array (path)
#import array (int)
typedef array<int> array<bool>;

class pager_rep {
public:
  edit_env env;
  hashmap<string,tree> style;

  bool         paper;
  bool         show_hf;
  SI           text_height;
  SI           width;
  SI           height;
  SI           odd;
  SI           even;
  SI           top;
  SI           bot;
  SI           head_sep;
  SI           foot_sep;
  space        prev_vspc;
  bool         prev_nobr;

  SI           cur_top;
  array<box>   pages;
  array<path>  pages_st;
  array<path>  pages_en;
  array<int>   pages_fl;

  space        cur_spc;
  space        cur_sep;
  array<box>   lines_bx;
  array<space> lines_ht;
  array<path>  lines_st;
  array<path>  lines_en;
  array<int>   lines_fl;

  array<paragraph> p;
  array<page_item> l;

public:

  pager_rep (edit_env enc);

  void start_page ();
  void print (page_item item);
  void end_page (bool flag);
  void insert_paragraph (paragraph par, int nr, bool empty);
  box  make_header ();
  box  make_footer ();
  box  make_pages ();

  friend class paragraph_rep;
};

typedef pager_rep* pager;

#endmodule // pager
