
/******************************************************************************
* MODULE     : paragraph.gen.h
* DESCRIPTION: The result of typesetting a paragraph is
*              an instance of the paragraph class
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <Boxes/boxes.gen.h>
#include <env.gen.h>
#include <data.gen.h>
#include <Document/page_item.gen.h>

#module paragraph
#import boxes
#import env
#import data
#import page_item

class paragraph_rep: public concrete_struct {
public:
  int                  status;  // 0: uninitialized, 1: invalid, 2: processed
  hashmap<string,tree> change;  // change in environment
  rectangle            r;       // bounding rectangle on screen
  array<page_item>     l;       // the typesetted paragraph

  bool  new_par_flag;
  space vspc1, vspc2;
  space vspc_before, vspc_after;
  bool  nobr1, nobr2;
  bool  nobr_before, nobr_after;
  int   last_break;
  array<page_item> ctrl;

  SI    height;  // default distance between successive base lines
  SI    sep;     // minimal separation of ink
  SI    hor_sep; // min. hor. ink sep. when lines are shoved into each other
  SI    bot;     // logical bottom of lines
  SI    top;     // logical top of lines

  paragraph_rep ();
  void set_env_vars (SI height, SI ink_sep, SI ink_mar, SI bot, SI top);

  SI   shove_in (box b1, box b2);
  void print (box b, path b, path q, int f);
  void print (tree t);
  void print (space spc);
  void flush ();
  void penalty (int pen);
  void new_paragraph ();
  void vspace_before (space spc);
  void vspace_after (space spc);
  void no_page_break_before ();
  void no_page_break_after ();
};

class paragraph {
#import concrete (paragraph, paragraph_rep)
  paragraph ();
  bool operator == (paragraph item2);
  bool operator != (paragraph item2);
};
#import code_concrete (paragraph, paragraph_rep)

ostream& operator << (ostream& out, paragraph item);
#define no_tree_converter<paragraph>
#import array(paragraph)

#endmodule // paragraph
