
/******************************************************************************
* MODULE     : ps_font.gen.cc
* DESCRIPTION: post-script fonts
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <font.gen.h>
#include <Boxes/construct.gen.h>

#module code_ps_font
#import font
#import construct_boxes

/******************************************************************************
* The ps_font representation
******************************************************************************/

struct ps_font_rep: font_rep {
  server_font fn;

  ps_font_rep (display dis, string name, string family, int size, int dpi);
  box  convert (string s, color col, SI len1, SI len2);
};

/******************************************************************************
* The implementation
******************************************************************************/

ps_font_rep::ps_font_rep (display dis, string name,
			  string family, int size, int dpi):
  font_rep (dis, name)
{
  fn= dis->server_ps_font (family, size, dpi);
  copy_parameters (fn);
}

box
ps_font_rep::convert (string s, color col, SI len1, SI len2) {
  (void) len1; (void) len2;
  return text_box (s, fn, col);
}

font
ps_font (display dis, string family, int size, int dpi) {
  string name= "ps:" * family * as_string (size) * "@" * as_string (dpi);
  if (resource<font> -> contains (name)) return font (name);
  else return new ps_font_rep (dis, name, family, size, dpi);
}

#endmodule // code_ps_font
