
/******************************************************************************
* MODULE     : composite_event.gen.cc
* DESCRIPTION: Events for modification of composite widgets
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "composite_event.gen.h"

#module code_composite_event
#import composite_event

/******************************************************************************
* Events for composite widgets
******************************************************************************/

clean_event_rep::clean_event_rep ():
  event_rep (CLEAN_EVENT) {}
clean_event_rep::operator tree () { return "clean_event"; }
#import code_event (clean_event, clean_event_rep)

event emit_clean () {
  return new clean_event_rep (); }

insert_event_rep::insert_event_rep (string s2, widget w2):
  event_rep (INSERT_EVENT), s (s2), w (w2) {}
insert_event_rep::operator tree () {
  return tree ("insert_event", s); }
#import code_event (insert_event, insert_event_rep)

event emit_insert (string s, widget w) {
  return new insert_event_rep (s, w); }

remove_event_rep::remove_event_rep (string s2):
  event_rep (REMOVE_EVENT), s (s2) {}
remove_event_rep::operator tree () {
  return tree ("remove_event", s); }
#import code_event (remove_event, remove_event_rep)

event emit_remove (string s) {
  return new remove_event_rep (s); }

#endmodule // code_composite_event
