 
/******************************************************************************
* MODULE     : specific_font.gen.h
* DESCRIPTION: TeX fonts and ps fonts
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <server_font.gen.h>
#include <tex.gen.h>

#module specific_font
#import display
#import tex

/******************************************************************************
* postscript fonts
******************************************************************************/

struct ps_char_prop {
  SI x1, x2;
  SI x3, y3;
  SI x4, y4;
};

struct server_ps_font_rep: public server_font_rep {
protected:
  ps_char_prop c [256];
  string       family;
  int          size;
  int          dpi;

  void initialize_parameters ();

public:
  server_ps_font_rep (string family, int size, int dpi);
  void get_extents (QN c, int n,
		    SI& x1, SI& y1, SI& x2, SI& y2,
		    SI& x3, SI& y3, SI& x4, SI& y4);
  void get_extents (string s,
		    SI& x1, SI& y1, SI& x2, SI& y2,
		    SI& x3, SI& y3, SI& x4, SI& y4);
  SI right_correction (QN c, int n);
  SI right_correction (string s);
};

/******************************************************************************
* tex fonts
******************************************************************************/

struct server_tex_font_rep: public server_font_rep {
  tex_font_metric tfm;
  pk_char_set     pk;
  double          unit;

protected:
  void get_extents (QN c,
		    SI& x1, SI& y1, SI& x2, SI& y2,
		    SI& x3, SI& y3, SI& x4, SI& y4);
  void get_extents_sub (QN c,
			SI& x1, SI& y1, SI& x2, SI& y2,
			SI& x3, SI& y3, SI& x4, SI& y4);

public:
  server_tex_font_rep (string family, int size, int dpi, int dsize);
  void get_extents (QN c, int n,
		    SI& x1, SI& y1, SI& x2, SI& y2,
		    SI& x3, SI& y3, SI& x4, SI& y4);
  void get_extents (string s,
		    SI& x1, SI& y1, SI& x2, SI& y2,
		    SI& x3, SI& y3, SI& x4, SI& y4);
  SI right_correction (QN c, int n);
  SI right_correction (string s);
};

#endmodule // specific_font
