
/******************************************************************************
* MODULE     : separator_widget.gen.cc
* DESCRIPTION: Widgets for filling up space between a group of widgets.
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <Widget/basic_widget.gen.h>

#module code_separator_widget
#import basic_widget

/******************************************************************************
* Glue widgets
******************************************************************************/

class separator_widget_rep: public basic_widget_rep {
  SI   pre, post;

public:
  separator_widget_rep (display dis, SI pre, SI post);
  operator tree ();

  void handle_get_size (get_size_event ev);
  void handle_repaint (repaint_event ev);
};

separator_widget_rep::separator_widget_rep (display dis, SI pre2, SI post2):
  basic_widget_rep (dis), pre (pre2), post (post2) {}

separator_widget_rep::operator tree () {
  return "separator";
}

void
separator_widget_rep::handle_get_size (get_size_event ev) {
  if (ev->mode==-1) ev->w= 0;
  if (ev->mode==1) dis->get_extents (ev->w, ev->h);
  ev->h= 2*PIXEL+ pre+ post;
}

void
separator_widget_rep::handle_repaint (repaint_event ev) {
  layout_default (win, ev->x1, ev->y1, ev->x2, ev->y2);
  win->set_color (layout_dark (win));
  win->set_line_style (PIXEL);
  win->line (ev->x1, -pre-PIXEL, ev->x2, -pre-PIXEL);
  win->set_color (dis->white);
  win->set_line_style (PIXEL);
  win->line (ev->x1, -pre-2*PIXEL, ev->x2, -pre-2*PIXEL);
}

/******************************************************************************
* Interface
******************************************************************************/

widget
separator_widget (display dis, SI pre, SI post) {
  return new separator_widget_rep (dis, pre, post);
}

#endmodule // code_separator_widget
