
/******************************************************************************
* MODULE     : x_font.gen.h
* DESCRIPTION: Abstract display class
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <PsDevice/specific_font.gen.h>

#module x_font
#import specific_font

/************************** postscript fonts *********************************/

struct x_ps_font_rep: server_ps_font_rep {
  x_display dis;
  hashmap<int,Font> the_fn;

  x_ps_font_rep (x_display dis, string family, int size, int dpi);
  ~x_ps_font_rep ();
  void prepare (int sf);
};
typedef x_ps_font_rep* x_ps_font;

/****************************** TeX fonts ************************************/

struct Bitmap_rep {
  Pixmap bm;
  int width, height;
  SI xoff, yoff;
};
typedef Bitmap_rep* Bitmap;

struct x_tex_font_rep: public server_tex_font_rep {
  x_display dis;
  hashmap<font_mod,pointer> the_pms;
  hashmap<int,pointer>      the_bms;

  x_tex_font_rep (x_display dis, string fam, int size, int dpi, int dsize);
  ~x_tex_font_rep ();
  void prepare (int sf, color fg, color bg);
  Bitmap get_bitmap (int c, int sf);
  Pixmap get_pixmap (int c, int sf, color fg, color bg);
};
typedef x_tex_font_rep* x_tex_font;

#endmodule // x_font
