
/******************************************************************************
* MODULE     : server_font.gen.h
* DESCRIPTION: Abstract server fonts
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public licence and comes WITHOUT
* ANY WARRENTY WHATSOEVER. See the file $TEXMACS_PATH/LICENCE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <string.gen.h>
#include <space.gen.h>

#module server_font
#import string
#import space

struct server_font_rep {
  string   name;             // name of the font
  int      type;             // ps font = 0, TeX font = 1
  SI       design_size;      // design size in points*SIZE_POINT
  SI       display_size;     // display size in points*PIXEL
  double   slope;            // italic slope
  space    spc;              // usual space between words
  space    extra;            // extra space at end of words

  SI       y1;               // bottom y position
  SI       y2;               // top y position
  SI       yfrac;            // vertical position fraction bar
  SI       ysub;             // base line for subscripts
  SI       ysup;             // base line for superscripts

  SI       wpt;              // width of one point in font
  SI       wquad;            // wpt * design size in points
  SI       wunit;            // unit width for extendable fonts
  SI       wfrac;            // width fraction bar
  SI       wsqrt;            // width horzontal line in square root
  SI       wneg;             // width of negation line

  inline server_font_rep (string name2): name (name2) {}
  inline virtual ~server_font_rep () {}
  virtual void get_extents (unsigned char c, int n,
			    SI& x1, SI& y1, SI& x2, SI& y2,
			    SI& x3, SI& y3, SI& x4, SI& y4) = 0;
  virtual void get_extents (string s,
			    SI& x1, SI& y1, SI& x2, SI& y2,
			    SI& x3, SI& y3, SI& x4, SI& y4) = 0;
  virtual SI right_correction (unsigned char c, int n) = 0;
  virtual SI right_correction (string s) = 0;

  void var_get_extents (string s,
			SI& x1, SI& y1, SI& x2, SI& y2,
			SI& x3, SI& y3, SI& x4, SI& y4);
};
typedef server_font_rep* server_font;

#endmodule // server_font
