
#object-option -Wall

#object <prg.o>
#include <array.gen.cc>
#include <list.gen.cc>
#include <hashmap.gen.cc>
#include <rel_hashmap.gen.cc>
#include <Basic/program.gen.cc>
#include <Basic/instance.gen.cc>
#include <Basic/function.gen.cc>
#code
#import code_program
#import code_instance
#import code_function
#import code_array (program)
#import code_list (typed_program)
#import code_array (instance)
#import code_hashmap (string,program)
#import code_hashmap (string,array<instance>)
#define HM hashmap<string,array<instance>>
bool operator == (HM h1, HM h2) { (void) h1; (void) h2; return FALSE; }
bool operator != (HM h1, HM h2) { (void) h1; (void) h2; return TRUE; }
#import code_list (hashmap<string,array<instance>>)
#undef HM
#endobject

#object <compile.o>
#include <Executor/executor.gen.cc>
#include <Compiler/prg_env.gen.cc>
#include <Compiler/compiler.gen.cc>
#include <Compiler/coerce.gen.cc>
#code
#import code_executor
#import code_prg_env
#import code_compiler
#import code_coerce
#endobject

#object <comp_init.o>
#include <hashmap.gen.h>
#include <compiler.gen.h>
#include <Initialize/init_system.gen.cc>
#code
#import compiler
#import hashmap(string,string)
#import hashmap(string,program)
tree bool_to_tree (bool b) { return tree ((char*) (b? "true": "false")); }
void print_bool (bool b) { cout << (b? "true": "false"); }
#import code_prg_system
#endobject

#library <libprg>
#option -lm
#uses <basic>
#object <prg.o>
#object <compile.o>
#object <comp_init.o>
#endlibrary

#object <gen_init.o>
#include <Initialize/gen_init.gen.cc>
#code
#import code_gen_init
#endobject

#binary <gen_init>
#option -lm
#uses <basic>
#uses <prg>
#object <gen_init.o>
#endbinary
