
#object-option -Wall

#object <boxes.o>
#include <Boxes/Basic/boxes.gen.cc>
#include <Boxes/Basic/basic.gen.cc>
#include <Boxes/Basic/rubber.gen.cc>
#include <Boxes/Text/text.gen.cc>
#include <Boxes/Text/accented.gen.cc>
#include <Boxes/Text/delim.gen.cc>
#include <Boxes/Text/bigop.gen.cc>
#include <Boxes/Composite/composite.gen.cc>
#include <Boxes/Composite/concat.gen.cc>
#include <Boxes/Composite/stack.gen.cc>
#include <Boxes/Composite/math.gen.cc>
#include <Boxes/Composite/matrix.gen.cc>
#include <Boxes/Modifier/modifier.gen.cc>
#include <Boxes/Graphics/graphics.gen.cc>
#code
#import code_boxes
#import code_basic_boxes
#import code_rubber_boxes
#import code_text_boxes
#import code_accented_boxes
#import code_delim_boxes
#import code_bigop_boxes
#import code_composite_boxes
#import code_concat_boxes
#import code_stack_boxes
#import code_math_boxes
#import code_matrix_boxes
#import code_modifier_boxes
#import code_graphics_boxes
#endobject

#object <font.o>
#include <Boxes/construct.gen.h>
#include <Fonts/font.gen.cc>
#include <Fonts/tex_font.gen.cc>
#include <Fonts/tex_rubber_font.gen.cc>
#include <Fonts/ps_font.gen.cc>
#include <Fonts/ps_rubber_font.gen.cc>
#include <Fonts/math_font.gen.cc>
#include <Fonts/find_font.gen.cc>
#code
#import construct_boxes
#import code_font
#import code_tex_font
#import code_tex_rubber_font
#import code_ps_font
#import code_ps_rubber_font
#import code_math_font
#import code_find_font
#endobject

#object <data.o>
#include <Data/data.gen.cc>
#include <Data/env.gen.cc>
#code
#import code_data
#import code_env
#endobject

#object <paragraph.o>
#include <Atom/typesetter.gen.cc>
#include <Paragraph/line_box.gen.cc>
#include <Paragraph/line_item.gen.cc>
#include <Paragraph/line_breaker.gen.cc>
#include <Paragraph/liner.gen.cc>
#include <Paragraph/line_pass1.gen.cc>
#include <Paragraph/line_pass2.gen.cc>
#include <Paragraph/line_pass3.gen.cc>
#code
#import code_typesetter
#import code_line_boxes
#import code_line_item
#import code_line_breaker
#import code_liner
#import code_line_pass1
#import code_line_pass2
#import code_line_pass3
#endobject

#object <document.o>
#include <Boxes/construct.gen.h>
#include <Document/paragraph.gen.cc>
#include <Document/page_box.gen.cc>
#include <Document/page_item.gen.cc>
#include <Document/page_breaker.gen.cc>
#include <Document/pager.gen.cc>
#include <Document/document.gen.cc>
#code
#import construct_boxes
#import code_paragraph
#import code_page_boxes
#import code_page_item
#import code_page_breaker
#import code_pager
#import code_document
#endobject

#library <libtypeset>
#option -lm +X-windows
#uses <basic>
#uses <resource>
#uses <window>
#uses <prg>
#object <boxes.o>
#object <font.o>
#object <data.o>
#object <paragraph.o>
#object <document.o>
#endlibrary
